unit NumbersLib;

{$mode objfpc}{$H+}

interface

uses

  Classes, SysUtils;

const
  Operators = ['+', '-', '*', '/'];


  function GetOperandsCount(Formula: string): Integer;
  function GetOperator(Formula: string; Index: Integer): char;
  function GetOperandValue(Formula: string; Index: Integer): Double;
  function SimpleCalculate(Formula: string): Double;
  function PriorityCalculate(Formula: string): string;





implementation



function GetOperandValue(Formula: string; Index: Integer): Double;
var
  i, j: Integer;
  Num: string;
  Start: Integer;
begin
  Start:= 1;
  for i:= 1 to Index do
  begin
    Num:= '';
    for j:= Start to Length(Formula) do
    begin
      Inc(Start);
      if Formula[j] in ['0' .. '9', '.'] then
        Num:= Num + Formula[j]
      else
        Break;
    end;
  end;
  Result:= StrToFloat(Num);

end;

function GetOperandsCount(Formula: string): Integer;
var
  i: Integer;
begin
  Result:= 0;
  for i:= 1 to Length(Formula) do
    if Formula[i] in Operators then
      Inc(Result);
  if Result > 0 then
    Inc(Result);
end;

function GetOperator(Formula: string; Index: Integer): char;
var
  i: Integer;
  Count: Integer;
begin
  Count:= 0;
  for i:= 1 to Length(Formula) do
  begin
    if Formula[i] in Operators then
    begin
      Inc(Count);
      if Index = Count then
      begin
        Result:= Formula[i];
        Break;
      end;
    end;
  end;
end;

function CalculateNumbers(Op1: Double; Op2: double; AOperator: char): Double;
begin
  case AOperator of
    '+': Result:= Op1 + Op2;
    '*': Result:= Op1 * Op2;
    '-': Result:= Op1 - Op2;
    '/': Result:= Op1 / Op2;
    else
      Result:= 0;
  end;
end;

function PriorityCalculate(Formula: string): string;
var
  i, j: Integer;
  OC: Integer;
  Calc: Double;
begin
  Result:= '';
  OC:= GetOperandsCount(Formula);
  for i:= 1 to OC do
    if (i <> OC) and (GetOperator(Formula, i) in ['*', '/']) then
    begin
      Calc:= CalculateNumbers(GetOperandValue(Formula, i), GetOperandValue(Formula, i + 1),
        GetOperator(Formula, i));
      Result:= Result + FloatToStr(Calc);
    end
    else
    begin
      if (i = 1) or (not (Getoperator(Formula, i - 1) in ['*', '/'])) then
        Result:= Result + FloatToStr(GetOperandValue(Formula, i));
      if i <> OC then
        Result:= Result + GetOperator(Formula, i);
    end;

end;

function SimpleCalculate(Formula: string): Double;
var
  i: Integer;
  OperandsCount: Integer;
  Op1, Op2: Double;
  Calc: Double;
begin
  Formula:= PriorityCalculate(Formula);
  OperandsCount:= GetOperandsCount(Formula);
  Result:= GetOperandValue(Formula, 1);
  for i:= 2 to OperandsCount do
  begin
    Op2:= GetOperandValue(Formula, i);
    Result:= CalculateNumbers(Result, Op2, GetOperator(Formula, i - 1));
  end;
end;

end.

